<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_WarningDate ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_WarningDate extends AbstractStructArrayBase
{
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_WarningDate[]
     */
    public $Date;
    /**
     * Constructor method for ArrayOfJP_WarningDate
     * @uses ArrayOfJP_WarningDate::setDate()
     * @param \StructType\JP_WarningDate[] $date
     */
    public function __construct(array $date = array())
    {
        $this
            ->setDate($date);
    }
    /**
     * Get Date value
     * @return \StructType\JP_WarningDate[]|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * This method is responsible for validating the values passed to the setDate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDateForArrayConstraintsFromSetDate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_WarningDateDateItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_WarningDateDateItem instanceof \StructType\JP_WarningDate) {
                $invalidValues[] = is_object($arrayOfJP_WarningDateDateItem) ? get_class($arrayOfJP_WarningDateDateItem) : sprintf('%s(%s)', gettype($arrayOfJP_WarningDateDateItem), var_export($arrayOfJP_WarningDateDateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Date property can only contain items of type \StructType\JP_WarningDate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Date value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_WarningDate[] $date
     * @return \ArrayType\ArrayOfJP_WarningDate
     */
    public function setDate(array $date = array())
    {
        // validation for constraint: array
        if ('' !== ($dateArrayErrorMessage = self::validateDateForArrayConstraintsFromSetDate($date))) {
            throw new \InvalidArgumentException($dateArrayErrorMessage, __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Add item to Date value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_WarningDate $item
     * @return \ArrayType\ArrayOfJP_WarningDate
     */
    public function addToDate(\StructType\JP_WarningDate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_WarningDate) {
            throw new \InvalidArgumentException(sprintf('The Date property can only contain items of type \StructType\JP_WarningDate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Date[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_WarningDate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_WarningDate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_WarningDate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_WarningDate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_WarningDate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Date
     */
    public function getAttributeName()
    {
        return 'Date';
    }
}
